import { Injectable } from '@nestjs/common';
import { UsersService } from '../users/users.service';
import { InputLoginDto } from './dto/input-login.dto';
import { hashPassword } from '../helper/hash_password';
import { User } from '../users/entities/user.entity';

@Injectable()
export class AuthService {
  constructor(private readonly usersService: UsersService) {}

  async validateUser({
    username,
    password,
  }: InputLoginDto): Promise<Omit<User, 'password'>> {
    const user = await this.usersService.findOne(username);

    if (user && user.password === (await hashPassword(password, user.salt))) {
      const { password, ...result } = user;

      return result;
    }

    return null;
  }
}
